/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/****************************************************************************/
/* MODULE NAME    : Omni Driver Debug Header File                           */
/* SOURCE NAME    : DEBUG.H                                                 */
/* AUTHOR         : Matt Rutkowski                                          */
/* DESCRIPTION    : */
/*                                                                          */
/*                                                                          */
/*--------------------------------------------------------------------------*/
/* CHANGE/MODIFICATION LOG :                                                */
/*--------------------------------------------------------------------------*/
/*                                                                          */
/****************************************************************************/

#ifdef DEBUG

//--------------------------------------
// Holds debug flags for DBPRINTIF()
//--------------------------------------
typedef struct DEBUGINFO
{
   BOOL bADDDEFINEDFORM;
   BOOL bADDUSERDEFINEDFORMENTRY;
   BOOL bADDUSERDEFINEDTRAYENTRY;
   BOOL bATTRIBUTEBUNDLESLINE;
   BOOL bATTRIBUTEBUNDLESAREA;
   BOOL bATTRIBUTEBUNDLESCHAR;
   BOOL bATTRIBUTEBUNDLESIMAGE;
   BOOL bATTRIBUTEBUNDLESMARKER;
   BOOL bBUILDAPPNAME;
   BOOL bCALCULATEFONTMETRICS;
   BOOL bCHECKLOGICALADDRESS;
   BOOL bCREATEUNIQUEFORMID;
   BOOL bCREATEUNIQUETRAYID;
   BOOL bDEBUGOUTPUT;
   BOOL bDELETEUSERDEFINEDFORMENTRY;
   BOOL bDELETEUSERDEFINEDTRAYENTRY;
   BOOL bDEVICEQUERYFONTATTRIBUTES;
   BOOL bDEVICEQUERYFONTS;
   BOOL bDRVINSTALL;
   BOOL bENABLE_BEGIN_CLOSE_DC;
   BOOL bENABLE_COMPLETE_OPEN_DC;
   BOOL bENABLE_DISABLE_DC;
   BOOL bENABLE_DISABLE_PHYSICAL;
   BOOL bENABLE_ENABLE_DC;
   BOOL bENABLE_FILL_LOGICAL;
   BOOL bENABLE_FILL_PHYSICAL;
   BOOL bENABLE_RESET_DC;
   BOOL bENABLE_RESTORE_DC;
   BOOL bENABLE_SAVE_DC;
   BOOL bFILLFONTLIST;
   BOOL bFILLFORMLIST;
   BOOL bFILLMEDIALIST;
   BOOL bFILLPRINTMODELIST;
   BOOL bFILLRESOLUTIONLIST;
   BOOL bFILLTRAYLIST;
   BOOL bFINDPRINTERNAME;
   BOOL bFORMIDFROMNAME;
   BOOL bFORMINFOFROMID;
   BOOL bFORMINFOFROMNAME;
   BOOL bFORMNAMEFROMID;
   BOOL bFREESTRINGTABLE;
   BOOL bFREEUSERDEFINEDFORMLIST;
   BOOL bFREEUSERDEFINEDTRAYLIST;
   BOOL bCREATENOTEBOOKPAGES;
   BOOL bGETDEFAULTFONTINFO;
   BOOL bGETDEFAULTFORMINFO;
   BOOL bGETIDSFROMCONNID;
   BOOL bINITSTRINGTABLE;
   BOOL bISFORMNAMEUNIQUE;
   BOOL bMEDIANAMEFROMID;
   BOOL bOMNICREATEHELPINSTANCE;
   BOOL bOMNIDESTROYHELPINSTANCE;
   BOOL bOS2_PM_DRV_DEVICENAMES;
   BOOL bOS2_PM_DRV_DEVMODE;
   BOOL bPDRIVERFROMDEVICENAME;
   BOOL bPDEVICEFROMDEVICENAME;
   BOOL bQUERYDEVICEBITMAPS;
   BOOL bQUERYDEVICECAPS;
   BOOL bQUERYDEVRESOURCE2;
   BOOL bQUERYHARDCOPYCAPS;
   BOOL bREADUSERDEFINEDFORMLIST;
   BOOL bREADUSERDEFINEDTRAYLIST;
   BOOL bSAVEUSERDEFINEDFORMLIST;
   BOOL bSETDRIVERDATADEFAULTS;
   BOOL bSUBINITJOB;
   BOOL bSUBRASTER;
   BOOL bSUBNEWPAGE;
   BOOL bSUBTERMJOB;
   BOOL bSUBABORTJOB;
   BOOL bSUBRASTERQUERY;
   BOOL bTRAYNAMEFROMID;
   BOOL bCHARSTRING;
   BOOL bREALIZEFONT;
   BOOL bDEVICEPALETTE;
   BOOL bDEVESC_STARTDOC;
   BOOL bDEVESC_RAWDATA;
   BOOL bDEVESC_ENDDOC;
   BOOL bDEVESC_NEWFRAME;
   BOOL bDEVESC_ABORTDOC;
   BOOL bDEVESC_QUERYHALFTONESUPPORT;
   BOOL bDEVESC_QUERYPATTERN;
   BOOL bDEVESC_QUERYESCSUPPORT;
   BOOL bDEVESC_GETSCALINGFACTOR;
   BOOL bDEVESC_QUERYVIOCELLSIZES;
   BOOL bDEVESC_QUERYACTUALRESOLUTION;
   BOOL bDEVESC_GETCP;
   BOOL bDEVESC_NEXTBAND;
   BOOL bDEVESC_DRAFTMODE;
   BOOL bDEVESC_FLUSHOUTPUT;
   BOOL bDEVESC_CHAR_EXTRA;
   BOOL bDEVESC_BREAK_EXTRA;
   BOOL bDEVESC_SETMODE;
   BOOL bDEVESC_DBE_FIRST;
   BOOL bDEVESC_DBE_LAST;
   BOOL bDEVESC_STD_JOURNAL;
} DEBUGINFO;
typedef DEBUGINFO FAR *PDEBUGINFO;

#endif
