/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = HP.H
 *
 * DESCRIPTIVE NAME =
 *
 *
 * VERSION = V3.0
 *
 * DATE
 *
 * DESCRIPTION
 *
 * FUNCTIONS
 *
 * NOTES
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 * EXTERNAL FUNCTIONS
 *
*/
#pragma pack(1)

/*****************************************************************************/
// DEFINES . . .
/*****************************************************************************/
#define MAX_OPTION_LEN 41
#define RC_not_found 99;

/*****************************************************************************/
// TYPEDEFS . . .
/*****************************************************************************/
typedef struct
{
  INT        iColorSmart;
  INT        iColorModel;
  INT        iPantone;
  INT        iPCCText;
  INT        iPCCGraf;
  INT        iPCCImag;
  INT        iTextHalftone;
  INT        iGrafHalftone;
  INT        iImagHalftone;
  INT        iAppHalftone;
  INT        iImagSmooth;
} HPDLL, *PHPDLL;

/*****************************************************************************/
// FUNCTION PROTOTYPES . . .
/*****************************************************************************/
MRESULT ColorOptDlgProc( HWND, ULONG, MPARAM, MPARAM );
MRESULT MemoryDlgProc( HWND, ULONG, MPARAM, MPARAM );
VOID InitColorFeatProc( HWND );
LONG CreateColorSmartBitmap( HWND );
VOID InitOptionsProc( HWND );
VOID DefaultOptionsProc( HWND );

//@V3.0130814 -- CHANGE PARAMETERS FROM INT TO PSZ FOR ALL GET/SET FUNCTIONS
INT GetCurrColorSmartPPDVal( PSZ );
INT GetCurrColorModelPPDVal( PSZ );
INT GetCurrPantonePPDVal( PSZ );

INT GetCurrPrntrClrCntlPPDVal( PSZ );
INT GetCurrHalftonePPDVal( PSZ );
INT GetCurrAppHalftonePPDVal( PSZ );

INT SetCurrColorSmartPPDVal( PSZ, INT );
INT SetCurrColorModelPPDVal( PSZ, INT );
INT SetCurrPantonePPDVal( PSZ, INT );

INT SetCurrPrntrClrCntlPPDVal( PSZ, INT );
INT SetCurrHalftonePPDVal( PSZ, INT );
INT SetCurrAppHalftonePPDVal( PSZ, INT );
VOID SaveManColorControl( HWND );

/*****************************************************************************/
// DIALOG DEFINES . . .
/*****************************************************************************/
// we'll put this in when we figure out how to hook it -- right now it's
// in config.h
//#define JPNB_DLG_COLORFEAT          JPNB_NBDLG_5
//#define JPCO_TAB                    (JPNB_DLG_COLORFEAT + 1)
#define JPCO_COLORSMART             (JPNB_DLG_COLORFEAT + 2)
#define JPCO_RAD_COLORSMART         (JPNB_DLG_COLORFEAT + 3)
#define JPCO_RAD_MAN_CLR            (JPNB_DLG_COLORFEAT + 4)
#define JPCO_CHK_GRAY               (JPNB_DLG_COLORFEAT + 5)
#define JPCO_MYOPTIONS2             (JPNB_DLG_COLORFEAT + 6)
#define JPCO_PANTONE                (JPNB_DLG_COLORFEAT + 7)

#define JPNB_DLG_CONTONE            0x0E00
#define JPOP_VIVID_COLOR            (JPNB_DLG_CONTONE + 1)
#define JPOP_PROCESS_BLUE           (JPNB_DLG_CONTONE + 2)
#define JPOP_NOADJ_COLOR            (JPNB_DLG_CONTONE + 3)
#define JPOP_TEXTCONTROL_TEXT       (JPNB_DLG_CONTONE + 4)
#define JPOP_TEXT_PCC_VC            (JPNB_DLG_CONTONE + 5)
#define JPOP_TEXT_PCC_NA            (JPNB_DLG_CONTONE + 6)
#define JPOP_TEXT_PCC_MS            (JPNB_DLG_CONTONE + 7)
#define JPOP_GRAFCONTROL_TEXT       (JPNB_DLG_CONTONE + 8)
#define JPOP_GRAF_PCC_VC            (JPNB_DLG_CONTONE + 9)
#define JPOP_GRAF_PCC_NA            (JPNB_DLG_CONTONE + 10)
#define JPOP_GRAF_PCC_MS            (JPNB_DLG_CONTONE + 11)
#define JPOP_IMAGCONTROL_TEXT       (JPNB_DLG_CONTONE + 12)
#define JPOP_IMAG_PCC_VC            (JPNB_DLG_CONTONE + 13)
#define JPOP_IMAG_PCC_NA            (JPNB_DLG_CONTONE + 14)
#define JPOP_IMAG_PCC_MS            (JPNB_DLG_CONTONE + 15)
#define JPOP_DETAIL_TEXT            (JPNB_DLG_CONTONE + 16)
#define JPOP_SMOOTH_TEXT            (JPNB_DLG_CONTONE + 17)
#define JPOP_BASIC_TEXT             (JPNB_DLG_CONTONE + 18)
#define JPOP_TEXTHALFTONE_DETAIL    (JPNB_DLG_CONTONE + 19)
#define JPOP_TEXTHALFTONE_SMOOTH    (JPNB_DLG_CONTONE + 20)
#define JPOP_TEXTHALFTONE_BASIC     (JPNB_DLG_CONTONE + 21)
#define JPOP_GRAFHALFTONE_DETAIL    (JPNB_DLG_CONTONE + 22)
#define JPOP_GRAFHALFTONE_SMOOTH    (JPNB_DLG_CONTONE + 23)
#define JPOP_GRAFHALFTONE_BASIC     (JPNB_DLG_CONTONE + 24)
#define JPOP_IMAGHALFTONE_DETAIL    (JPNB_DLG_CONTONE + 25)
#define JPOP_IMAGHALFTONE_SMOOTH    (JPNB_DLG_CONTONE + 26)
#define JPOP_IMAGHALFTONE_BASIC     (JPNB_DLG_CONTONE + 27)
#define JPOP_APPHALFTONE            (JPNB_DLG_CONTONE + 28)
#define JPOP_DEFAULT_SETTINGS       (JPNB_DLG_CONTONE + 29)
#define JPOP_HELP                   (JPNB_DLG_CONTONE + 30)
#define JPOP_IMAGSMOOTH             (JPNB_DLG_CONTONE + 31)

#define JPSB_ICON_OBJECT 0x777
#define JPSB_GRAY_GRA               (JPSB_ICON_OBJECT + 10)
#define JPSB_GRAY_IMA               (JPSB_ICON_OBJECT + 11)
#define JPSB_GRAY_TEXT              (JPSB_ICON_OBJECT + 12)
#define JPSB_GRAPHICS               (JPSB_ICON_OBJECT + 13)
#define JPSB_IMAGE                  (JPSB_ICON_OBJECT + 14)
#define JPSB_TEXT                   (JPSB_ICON_OBJECT + 15)
#define COLORSMART_BITMAP           (JPSB_ICON_OBJECT + 16)

#define JPSB_ICONS                  0x888
#define ICON_GRAY_GRA               (JPSB_ICONS + 10)
#define ICON_GRAY_IMA               (JPSB_ICONS + 11)
#define ICON_GRAY_TEXT              (JPSB_ICONS + 12)
#define ICON_GRAPHICS               (JPSB_ICONS + 13)
#define ICON_IMAGE                  (JPSB_ICONS + 14)
#define ICON_TEXT                   (JPSB_ICONS + 15)
#define BITMAP_COLORSMART           (JPSB_ICONS + 16)

