/*DDK*************************************************************************/
/*                                                                           */
/* COPYRIGHT    Copyright (C) 1992 IBM Corporation                           */
/*                                                                           */
/*    The following IBM OS/2 source code is provided to you solely for       */
/*    the purpose of assisting you in your development of OS/2 device        */
/*    drivers. You may use this code in accordance with the IBM License      */
/*    Agreement provided in the IBM Developer Connection Device Driver       */
/*    Source Kit for OS/2. This Copyright statement may not be removed.      */
/*                                                                           */
/*****************************************************************************/
/**************************************************************************
 *
 * SOURCE FILE NAME = PRDINCLT.H
 *
 * DESCRIPTIVE NAME =
 *
 *
 * VERSION = V2.0
 *
 * DATE        : --/--/88
 *
 * DESCRIPTION : Global inlude file for all Printer Device Driver
 *               include files
 *
 * FUNCTIONS
 *
 * NOTES
 *
 * STRUCTURES
 *
 * EXTERNAL REFERENCES
 *
 * EXTERNAL FUNCTIONS
 *
*/


/*
**  Call the standard library for standard c functions, min, max and
**  abs.
*/
#include <stdlib.h>


/*
** Following defines select a subset of the definitions available
** from the standard OS2 Presentation Manager include header.
*/
#define INCL_DOS
#define INCL_DOSERRORS
#define INCL_DOSDEVICES
#define INCL_WIN
#define INCL_GREALL

#define INCL_DDIBUNDLES
#define INCL_DEV
#define INCL_DDICOMFLAGS
#define INCL_DDIMISC
#define INCL_GPIPRIMITIVES
#define INCL_GPIERRORS
#define INCL_GPIBITMAPS
#define INCL_GPILCIDS                    /* include font defs */
#define INCL_GPITRANSFORMS               /* include matrix defs */

/*
**  #include <os2.h>
*/
#include <os2def.h>
#include <bse.h>                         /* want to include base defs */
           /*
           **  bse.h in turn includes bsedos.h, bsesub.h, and bseerr.h
           */


#include <pmgpi.h>               /* include commonly used header file */
#if VER20
#include <pmbitmap.h>
#endif
#include <pmwin.h>
#define  PASCAL
#define  FAR
#define  INCL_VMANDDI
#define  INCL_GREALL
#define  INCL_GRE_DEVICESURFACE
#define  INCL_GRE_PAX
#include <ddi.h>
#include <pmddi.h>               /* include commonly used header file */

/*
** Following are includes for Printer Device Driver.
** Include here because majority of .c files need these headers
*/

/*
** Add support for second thread async output.
*/
#pragma pack(1)
#define INCL_GENPLIB_ALL
#define INCL_GENPLIB_LAYOUT
#include <genplib.h>

#include "prdbcone.h"
#include "prddcone.h"
#include "prdtypet.h"
#include "prddtypt.h"
#include "prdstypt.h"
#include "prdptypt.h"
#include "prddct.h"
#include "prdbtypt.h"
#include "innergre.h"       // InnerGre... macros.

/*
** FNULL is required for far pointer comparisons, so that the code is
** independent of memory model.
*/

#define FNULL                   0L

#define TRAP()  *((char far *) (long) -1) = 0


#define RASTER_ENGINE_22   0x0220
