PROJ = gpibtmp
CC = icc

#  /W3           - Warns of all non-ANSI usage
#  /G3           - Generate 80486 code
#  /DLINT_ARGS   - Check functional arguments against prototypes
#  /Sp           - Packs Structure
#  /Ti+          - Generates all debugger information
#  /Sm           - Allow all C Set/2 extensions including those for migration
#  /O+           - Optimize object code
#  /Gs+          - Stack checking
#  /Ge           - Build .EXE file
#  /Ss           - Allow for the // comments

CFLAGS  = /Ge- /Ti+ /O- /Oi- /Os- /Oc- /W3 /G3 /DLINT_ARGS /Sp /Sm /Gm+ /Gd+ /Gs+ /Ss

#
#  The following is to use the new libraries for Visual Age C/C++
#
LLIBS    = CPPOM30.LIB + OS2386.LIB

LFLAGS   =  /DE /CODEVIEW /STACK:64000 /NOD /ALIGN:16 /PACKC /PACKD /M /BASE:0x10000 

ICLCPPOPTS=/GM+ /GD+ /DIC_TRACE_ALL /DIC_DEVELOP /B" /PM:PM"

IMPLIB = implib/NOIGNORECASE

EXECFLAGS= $(ICLCPPOPTS)
EXELFLAGS=/B" /PM:PM"

MAPFILE  = gpibtmp.map
# LINKER   = link386
# old linker... the new linker is ilink
LINKER   = ilink
LRF      = echo > NUL
RC       = rc
DEF_FILE = gpibtmp.DEF
BITMAP    = GPIBTMP1.BMP GPIBTMP2.BMP GPIBTMP3.BMP GPIBTMP4.BMP GPIBTMP5.BMP


OBJS  = gpibtmp.obj   common.obj  \
                pttdllvr.obj

.dll.lib:
        $(IMPLIB) $*.lib $*.dll

compile = $(CC) /c $(CFLAGS)

all: $(PROJ).dll

.SUFFIXES:
.SUFFIXES: .sbr .obj .res .c .rc


GPIBTMP.OBJ : GPIBTMP.C  GPIBTMP.H PTTDLLDF.H COMMON.H PTT_DLL.H
  $(compile) /Fo$@ GPIBTMP.C

COMMON.OBJ      : COMMON.C COMMON.H
  $(compile) /Fo$@ COMMON.C

PTTDLLVR.OBJ    : PTTDLLVR.C  PTTDLLDF.H  ERRORS.H
  $(compile) /Fo$@ PTTDLLVR.C

gpibtmp.dll: $(OBJS) gpibtmp.RES
      $(LINKER) /nofree $(LFLAGS) \
          $(OBJS),gpibtmp.dll,gpibtmp.map,$(LLIBS),gpibtmp.def
  $(RC) gpibtmp.RES gpibtmp.dll

gpibtmp.RES: gpibtmp.RC $(BITMAP)
  $(RC) -r gpibtmp.RC gpibtmp.RES

