#ifndef GPICLIP_H
#define GPICLIP_H
/*****************************************************************************
 *\\ddd
 * Subtask Name: PDVT
 *
 * Module Name: GPICLIP
 *
 * Purpose: Include file for GpiClipping dll.
 *
 *  $header$
 *
 * Revision Log: 10/25/90, PDVT, Gisselle Labault
 *               - created initial file
 *               01/02/91, pdvt, gisselle labault
 *               - submitted for code review
 *
 * SRS References: Section 5.7
 *
 * Contents:  This file contains the following definitions:
 *              - function prototypes
 *              - define's specific to GPICLIP
 *
 * Limitations:
 *           none
 *\\end
 *****************************************************************************/

/* declare all dll functions */
VOID  APIENTRY InitTest(PVOID sel, PTESTINITINFO pInitInfo);

VOID  APIENTRY GpiClipPre(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GpiClipApp(HPS hPS, HWND hWndClient, BOOL SelectionCall);

VOID  APIENTRY GpiPtVisibleExh(HPS hPS, HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY GpiRectVisibleExh(HPS hPS, HWND hWndClient,BOOL SelectionCall);
VOID  APIENTRY GpiQueryClipRegionExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GpiQueryClipBoxExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GpiSetClipPathExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GpiExcludeClipRectExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GpiIntersectClipRectExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);
VOID  APIENTRY GpiOffsetClipRegionExh(HPS hPS, HWND hWndClient, BOOL SelectionCall);


#define NTESTS  10  /* number of functions or entry points in this dll */

#ifdef MAINSOURCEFILE

LONG ErrorCount;          //Error counter.

#endif

#endif
